// inet_addr: http://msdn.microsoft.com/en-us/library/windows/desktop/ms738563%28v=vs.85%29.aspx
// IcmpSendEcho2: http://msdn.microsoft.com/en-us/library/windows/desktop/aa366051%28v=vs.85%29.aspx
// IcmpCreateFile: http://msdn.microsoft.com/en-us/library/windows/desktop/aa366045%28v=vs.85%29.aspx
// IcmpEchoReplyStructure: http://msdn.microsoft.com/en-us/library/windows/desktop/aa366053%28v=vs.85%29.aspx

#import "Ws2_32.dll"
   int inet_addr(string IpAddressStr);
#import

#import "Iphlpapi.dll"
   int IcmpCreateFile();
   bool IcmpCloseHandle(int IcmpHandle);
   int IcmpSendEcho2(int IcmpHandle, int Event, int ApcRoutine, int ApcContext, int DestinationAddress,
         string RequestData, int RequestSize, int RequestOptions, int& ReplyBuffer[], int ReplySize, int Timeout);
   int GetIpErrorString(int ErrorCode, int& Buffer[], int& Size[]);
#import

#define INADDR_NONE 0xffffffff
#define INADDR_ANY 0x00000000

int start() {
   string ipAddressStr = "97.23.119.66";
   bool isSuccess = pingIcmp(ipAddressStr);
   if (isSuccess) {
      Alert("Ping " + ipAddressStr + ": Ok.");
   } else {
      Alert("Ping " + ipAddressStr + ": Failed.");
   }
}

bool pingIcmp(string ipAddressStr) {
   int ipAddress = inet_addr(ipAddressStr);
   if (ipAddress == INADDR_NONE || ipAddress == INADDR_ANY) {
      Print("Icmp: Invalid IP adress: " + ipAddressStr);
      return(false);
   }
   
   string sendData = "Data Buffer";
   int replySize = StringLen(sendData) + 256;
   int replyBuffer[];
   int newSize = ArrayResize(replyBuffer, replySize);
   if (newSize != replySize || ArraySize(replyBuffer) != replySize) {
      Print("Icmp: Cannot allocate reply buffer array. Last error: " + GetLastError());
      return(false);
   }
   
   int handleIcmpFile = IcmpCreateFile();
   if (handleIcmpFile == 0) {
      Print("IcmpCreateFile: Unable to open handle.");
      return(false);
   }
   
   Print("Icmp: Sending echo to " + ipAddressStr);
   int sendEchoRetVal = IcmpSendEcho2(handleIcmpFile, 0, 0, 0, ipAddress, sendData, StringLen(sendData), 0, 
         replyBuffer, replySize, 1000);
         
   if (sendEchoRetVal != 0) {
      Print("Icmp: Alive, RoundTripTime = " + replyBuffer[2] + "ms");
   } else {
      Print("Icmp: Error, Status = " + replyBuffer[1] + ": " + getIpErrorStr(replyBuffer[1]));
   }
   
   IcmpCloseHandle(handleIcmpFile);
   return(sendEchoRetVal != 0);
}

string getIpErrorStr(int status) {
   int i, char1, char2;
   string errorStr = "";
   int size[1];
   size[0] = 256;
   int buffer[];
   int newSize = ArrayResize(buffer, size[0]);
   if (newSize != size[0] || ArraySize(buffer) != size[0]) {
      Print("Icmp: Cannot allocate buffer array for error string. Last error: " + GetLastError());
      return("Unknown error.");
   }
   int formattingError = GetIpErrorString(status, buffer, size);
   if (formattingError != 0) {
      return("Unknown error.");
   }
   for (i = 0; i < size[0]; i++) {
      char1 = buffer[i] & 255;
      char2 = (buffer[i] >> 16) & 255;
      if (char1 == 0 && char2 == 0) {
         break;
      }
      if (char1 != 0) {
         errorStr = errorStr + CharToStr(char1);
      }
      if (char2 != 0) {
         errorStr = errorStr + CharToStr(char2);
      }
   }
   return(errorStr);
}

